=== modified file 'DBUS-API'
--- DBUS-API	2014-08-10 14:13:02 +0000
+++ DBUS-API	2012-01-15 20:27:28 +0000
@@ -150,6 +150,9 @@
     milliseconds, depending on ApprovedByDefault.  Approve() can now
     usefully be called on this client object.
     
+*** PropertyChanged(s: Property, v: Value)
+    The Property on this client has changed to Value.
+    
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 

=== modified file 'Makefile'
--- Makefile	2015-06-28 16:35:27 +0000
+++ Makefile	2014-07-17 03:24:57 +0000
@@ -26,7 +26,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.6.9
+version=1.6.7
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -106,8 +106,7 @@
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
 	plugins.d/plymouth
-PLUGIN_HELPERS=
-CPROGS=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
+CPROGS=plugin-runner $(PLUGINS)
 PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
 DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
 	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
@@ -274,7 +273,6 @@
 	@echo "###################################################################"
 # We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
-		--plugin-helper-dir=plugin-helpers \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
 		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
@@ -358,7 +356,6 @@
 	if [ "$(CONFDIR)" != "$(LIBDIR)/mandos" ]; then \
 		install --mode=u=rwx \
 			--directory "$(CONFDIR)/plugins.d"; \
-		install --directory "$(CONFDIR)/plugin-helpers"; \
 	fi
 	install --mode=u=rwx,go=rx --directory \
 		"$(CONFDIR)/network-hooks.d"

=== modified file 'NEWS'
--- NEWS	2014-10-05 20:08:58 +0000
+++ NEWS	2014-07-17 03:24:57 +0000
@@ -1,18 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.6.9 (2014-10-05)
-* Server
-** Changed to emit standard D-Bus signal when D-Bus properties change.
-   (The old signal is still emitted too, but marked as deprecated.)
-
-Version 1.6.8 (2014-08-06)
-* Client
-** Bug fix: mandos-keygen now generates working SSH checker commands.
-* Server
-** Bug fix: "mandos-monitor" now really redraws screen on Ctrl-L.
-** Now requires Python 2.7.
-
 Version 1.6.7 (2014-07-17)
 * Client
 ** Bug fix: Now compatible with GPGME 1.5.0.

=== modified file 'TODO'
--- TODO	2014-10-05 19:39:25 +0000
+++ TODO	2014-07-14 21:41:08 +0000
@@ -23,7 +23,6 @@
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
 ** TODO [#C] Make start_mandos_communication() take "struct server".
-** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -33,6 +32,7 @@
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
 * askpass-fifo
+** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
 ** TODO [#B] lock stdin (with flock()?)
@@ -48,9 +48,6 @@
 ** kernel command line option for debug info
 
 * mandos (server)
-** TODO [#B] Work around Avahi issue
-   Avahi does not announce link-local addresses if any global
-   addresses exist: http://lists.freedesktop.org/archives/avahi/2010-March/001863.html
 ** TODO [#B] Log level							  :BUGS:
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
@@ -72,6 +69,9 @@
 ** TODO Use python-tlslite?
 ** TODO D-Bus AddClient() method on server object
 ** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods. :2:
+** TODO Emit [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-properties][org.freedesktop.DBus.Properties.PropertiesChanged]] signal	  :2:
+   TODO Deprecate se.recompile.Mandos.Client.PropertyChanged - annotate!
+   TODO Can use "invalidates" annotation to also emit on changed secret.
 ** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object :2:
    Deprecate methods GetAllClients(), GetAllClientsWithProperties()
    and signals ClientAdded and ClientRemoved.
@@ -80,13 +80,12 @@
 ** TODO Secret Service API?
    http://standards.freedesktop.org/secret-service/
 ** TODO Remove D-Bus interfaces with old domain name			  :2:
-** TODO Remove old string_to_delta format				     :2:
+** TODO Remove old string_to_delta format				  :2:
 ** TODO http://0pointer.de/blog/projects/stateless.html
 *** tmpfiles snippet to create /var/lib/mandos with right user+perms
 *** File in /usr/lib/sysusers.d to create user+group "_mandos"
 ** TODO Error handling on error parsing config files
 ** TODO init.d script error handling
-** TODO D-Bus server properties; address, port, interface, etc.		     :2:
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -94,7 +93,7 @@
 * mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Remove old string_to_delta format				     :2:
+** TODO Remove old string_to_delta format				  :2:
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with

=== modified file 'common.ent'
--- common.ent	2014-10-05 20:08:58 +0000
+++ common.ent	2014-07-17 03:24:57 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.9">
+<!ENTITY version "1.6.7">

=== modified file 'debian/changelog'
--- debian/changelog	2014-10-05 20:08:58 +0000
+++ debian/changelog	2014-07-17 03:24:57 +0000
@@ -1,25 +1,3 @@
-mandos (1.6.9-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/control (Build-Depends): Fix "still uses GnutLS 2.x" by
-    changing from "libgnutls-dev" to "libgnutls28-dev | gnutls-dev"
-    (Closes: #762349)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 05 Oct 2014 22:05:06 +0200
-
-mandos (1.6.8-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/control (Source: mandos/Build-Depends-Indep): Since upstream
-    now requires Python 2.7, depend on exactly the python2.7 package and
-    all the Python 2.7 versions of the python modules.
-    (Package: mandos/Depends): - '' - but still depend on python (>=2.7)
-    and the generic versions of the Python modules; this is for mandos-ctl
-    and mandos-monitor, both of which are compatible with Python 3, and
-    use #!/usr/bin/python.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Wed, 06 Aug 2014 22:55:24 +0200
-
 mandos (1.6.7-1) unstable; urgency=medium
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2014-10-08 21:03:05 +0000
+++ debian/control	2014-07-25 22:44:20 +0000
@@ -5,18 +5,18 @@
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
-	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev
-	| gnutls-dev, xsltproc, pkg-config
+	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
+	pkg-config
 Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
 	python2.7-dbus, python2.7-avahi, python2.7-gobject
-Standards-Version: 3.9.6
+Standards-Version: 3.9.5
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>= 2.7), python2.7, python-gnutls,
+Depends: ${misc:Depends}, python (<= 2.7), python2.7, python-gnutls,
 	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
 	python2.7-avahi, python-gobject, python2.7-gobject,
 	avahi-daemon, adduser, python-urwid, python2.7-urwid,

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2015-06-28 16:35:27 +0000
+++ initramfs-tools-hook	2014-07-16 23:44:54 +0000
@@ -70,13 +70,11 @@
 CONFDIR="/conf/conf.d/mandos"
 MANDOSDIR="/lib/mandos"
 PLUGINDIR="${MANDOSDIR}/plugins.d"
-PLUGINHELPERDIR="${MANDOSDIR}/plugins-helpers"
 HOOKDIR="${MANDOSDIR}/network-hooks.d"
 
 # Make directories
 install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
-	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}" \
-	"${DESTDIR}${PLUGINHELPERDIR}"
+	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}"
 install --owner=${mandos_user} --group=${mandos_group} --directory \
     --mode=u=rwx "${DESTDIR}${PLUGINDIR}"
 
@@ -100,21 +98,6 @@
     esac
 done
 
-# Copy the packaged plugin helpers
-for file in "$libdir"/mandos/plugin-helpers/*; do
-    base="`basename \"$file\"`"
-    # Is this plugin overridden?
-    if [ -e "/etc/mandos/plugin-helpers/$base" ]; then
-	continue
-    fi
-    case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
-	    : ;;
-	"*") : ;;
-	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
-    esac
-done
-
 # Copy any user-supplied plugins
 for file in /etc/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
@@ -126,17 +109,6 @@
     esac
 done
 
-# Copy any user-supplied plugin helpers
-for file in /etc/mandos/plugin-helpers/*; do
-    base="`basename \"$file\"`"
-    case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
-	    : ;;
-	"*") : ;;
-	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
-    esac
-done
-
 # Get DEVICE from initramfs.conf and other files
 . /etc/initramfs-tools/initramfs.conf
 for conf in /etc/initramfs-tools/conf.d/*; do

=== modified file 'mandos'
--- mandos	2014-10-08 21:07:10 +0000
+++ mandos	2014-07-25 22:44:20 +0000
@@ -88,10 +88,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-if sys.version_info.major == 2:
-    str = unicode
-
-version = "1.6.9"
+version = "1.6.7"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -107,8 +104,10 @@
         SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
         with contextlib.closing(socket.socket()) as s:
             ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                struct.pack(b"16s16x", interface))
-        interface_index = struct.unpack("I", ifreq[16:20])[0]
+                                struct.pack(str("16s16x"),
+                                            interface))
+        interface_index = struct.unpack(str("I"),
+                                        ifreq[16:20])[0]
         return interface_index
 
 
@@ -119,7 +118,7 @@
     syslogger = (logging.handlers.SysLogHandler
                  (facility =
                   logging.handlers.SysLogHandler.LOG_DAEMON,
-                  address = "/dev/log"))
+                  address = str("/dev/log")))
     syslogger.setFormatter(logging.Formatter
                            ('Mandos [%(process)d]: %(levelname)s:'
                             ' %(message)s'))
@@ -225,8 +224,9 @@
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
-        return super(AvahiError, self).__init__(value, *args,
-                                                **kwargs)
+        super(AvahiError, self).__init__(value, *args, **kwargs)
+    def __unicode__(self):
+        return unicode(repr(self.value))
 
 class AvahiServiceError(AvahiError):
     pass
@@ -275,31 +275,25 @@
         self.bus = bus
         self.entry_group_state_changed_match = None
     
-    def rename(self, remove=True):
+    def rename(self):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
             logger.critical("No suitable Zeroconf service name found"
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = str(self.server
-                        .GetAlternativeServiceName(self.name))
-        self.rename_count += 1
+        self.name = unicode(self.server
+                            .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
-        if remove:
-            self.remove()
+        self.remove()
         try:
             self.add()
         except dbus.exceptions.DBusException as error:
-            if (error.get_dbus_name()
-                == "org.freedesktop.Avahi.CollisionError"):
-                logger.info("Local Zeroconf service name collision.")
-                return self.rename(remove=False)
-            else:
-                logger.critical("D-Bus Exception", exc_info=error)
-                self.cleanup()
-                os._exit(1)
+            logger.critical("D-Bus Exception", exc_info=error)
+            self.cleanup()
+            os._exit(1)
+        self.rename_count += 1
     
     def remove(self):
         """Derived from the Avahi example code"""
@@ -343,8 +337,8 @@
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical("Avahi: Error in group state changed %s",
-                            str(error))
-            raise AvahiGroupError("State changed: {!s}"
+                            unicode(error))
+            raise AvahiGroupError("State changed: {0!s}"
                                   .format(error))
     
     def cleanup(self):
@@ -397,16 +391,23 @@
 
 
 class AvahiServiceToSyslog(AvahiService):
-    def rename(self, *args, **kwargs):
+    def rename(self):
         """Add the new name to the syslog messages"""
-        ret = AvahiService.rename(self, *args, **kwargs)
+        ret = AvahiService.rename(self)
         syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({}) [%(process)d]:'
+                               ('Mandos ({0}) [%(process)d]:'
                                 ' %(levelname)s: %(message)s'
                                 .format(self.name)))
         return ret
 
 
+def timedelta_to_milliseconds(td):
+    "Convert a datetime.timedelta() to milliseconds"
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
+
+
 class Client(object):
     """A representation of a client host served by this server.
     
@@ -467,6 +468,21 @@
                         "enabled": "True",
                         }
     
+    def timeout_milliseconds(self):
+        "Return the 'timeout' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.timeout)
+    
+    def extended_timeout_milliseconds(self):
+        "Return the 'extended_timeout' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.extended_timeout)
+    
+    def interval_milliseconds(self):
+        "Return the 'interval' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.interval)
+    
+    def approval_delay_milliseconds(self):
+        return timedelta_to_milliseconds(self.approval_delay)
+    
     @staticmethod
     def config_parser(config):
         """Construct a new dict of client settings of this form:
@@ -497,7 +513,7 @@
                           "rb") as secfile:
                     client["secret"] = secfile.read()
             else:
-                raise TypeError("No secret or secfile for section {}"
+                raise TypeError("No secret or secfile for section {0}"
                                 .format(section))
             client["timeout"] = string_to_delta(section["timeout"])
             client["extended_timeout"] = string_to_delta(
@@ -520,7 +536,7 @@
             server_settings = {}
         self.server_settings = server_settings
         # adding all client settings
-        for setting, value in settings.items():
+        for setting, value in settings.iteritems():
             setattr(self, setting, value)
         
         if self.enabled:
@@ -609,16 +625,14 @@
         if self.checker_initiator_tag is not None:
             gobject.source_remove(self.checker_initiator_tag)
         self.checker_initiator_tag = (gobject.timeout_add
-                                      (int(self.interval
-                                           .total_seconds() * 1000),
+                                      (self.interval_milliseconds(),
                                        self.start_checker))
         # Schedule a disable() when 'timeout' has passed
         if self.disable_initiator_tag is not None:
             gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = (gobject.timeout_add
-                                      (int(self.timeout
-                                           .total_seconds() * 1000),
-                                       self.disable))
+                                   (self.timeout_milliseconds(),
+                                    self.disable))
         # Also start a new checker *right now*.
         self.start_checker()
     
@@ -655,8 +669,8 @@
             self.disable_initiator_tag = None
         if getattr(self, "enabled", False):
             self.disable_initiator_tag = (gobject.timeout_add
-                                          (int(timeout.total_seconds()
-                                               * 1000), self.disable))
+                                          (timedelta_to_milliseconds
+                                           (timeout), self.disable))
             self.expires = datetime.datetime.utcnow() + timeout
     
     def need_approval(self):
@@ -693,9 +707,10 @@
         # Start a new checker if needed
         if self.checker is None:
             # Escape attributes for the shell
-            escaped_attrs = { attr:
-                                  re.escape(str(getattr(self, attr)))
-                              for attr in self.runtime_expansions }
+            escaped_attrs = dict(
+                (attr, re.escape(unicode(getattr(self, attr))))
+                for attr in
+                self.runtime_expansions)
             try:
                 command = self.checker_command % escaped_attrs
             except TypeError as error:
@@ -782,7 +797,7 @@
     # "Set" method, so we fail early here:
     if byte_arrays and signature != "ay":
         raise ValueError("Byte arrays not supported for non-'ay'"
-                         " signature {!r}".format(signature))
+                         " signature {0!r}".format(signature))
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
@@ -819,11 +834,11 @@
     """Decorator to annotate D-Bus methods, signals or properties
     Usage:
     
-    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true",
-                       "org.freedesktop.DBus.Property."
-                       "EmitsChangedSignal": "false"})
     @dbus_service_property("org.example.Interface", signature="b",
                            access="r")
+    @dbus_annotations({{"org.freedesktop.DBus.Deprecated": "true",
+                        "org.freedesktop.DBus.Property."
+                        "EmitsChangedSignal": "false"})
     def Property_dbus_property(self):
         return dbus.Boolean(False)
     """
@@ -836,7 +851,9 @@
 class DBusPropertyException(dbus.exceptions.DBusException):
     """A base class for D-Bus property-related exceptions
     """
-    pass
+    def __unicode__(self):
+        return unicode(str(self))
+
 
 class DBusPropertyAccessException(DBusPropertyException):
     """A property's access permissions disallows an operation.
@@ -865,7 +882,7 @@
         If called like _is_dbus_thing("method") it returns a function
         suitable for use as predicate to inspect.getmembers().
         """
-        return lambda obj: getattr(obj, "_dbus_is_{}".format(thing),
+        return lambda obj: getattr(obj, "_dbus_is_{0}".format(thing),
                                    False)
     
     def _get_all_dbus_things(self, thing):
@@ -921,7 +938,7 @@
             # signatures other than "ay".
             if prop._dbus_signature != "ay":
                 raise ValueError("Byte arrays not supported for non-"
-                                 "'ay' signature {!r}"
+                                 "'ay' signature {0!r}"
                                  .format(prop._dbus_signature))
             value = dbus.ByteArray(b''.join(chr(byte)
                                             for byte in value))
@@ -952,14 +969,6 @@
                                            value.variant_level+1)
         return dbus.Dictionary(properties, signature="sv")
     
-    @dbus.service.signal(dbus.PROPERTIES_IFACE, signature="sa{sv}as")
-    def PropertiesChanged(self, interface_name, changed_properties,
-                          invalidated_properties):
-        """Standard D-Bus PropertiesChanged() signal, see D-Bus
-        standard.
-        """
-        pass
-    
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
                          out_signature="s",
                          path_keyword='object_path',
@@ -1000,7 +1009,7 @@
                                               (prop,
                                                "_dbus_annotations",
                                                {}))
-                        for name, value in annots.items():
+                        for name, value in annots.iteritems():
                             ann_tag = document.createElement(
                                 "annotation")
                             ann_tag.setAttribute("name", name)
@@ -1009,11 +1018,11 @@
                 # Add interface annotation tags
                 for annotation, value in dict(
                     itertools.chain.from_iterable(
-                        annotations().items()
+                        annotations().iteritems()
                         for name, annotations in
                         self._get_all_dbus_things("interface")
                         if name == if_tag.getAttribute("name")
-                        )).items():
+                        )).iteritems():
                     ann_tag = document.createElement("annotation")
                     ann_tag.setAttribute("name", annotation)
                     ann_tag.setAttribute("value", value)
@@ -1075,7 +1084,7 @@
     """
     def wrapper(cls):
         for orig_interface_name, alt_interface_name in (
-            alt_interface_names.items()):
+            alt_interface_names.iteritems()):
             attr = {}
             interface_names = set()
             # Go though all attributes of the class
@@ -1198,7 +1207,7 @@
                                         attribute.func_closure)))
             if deprecate:
                 # Deprecate all alternate interfaces
-                iname="_AlternateDBusNames_interface_annotation{}"
+                iname="_AlternateDBusNames_interface_annotation{0}"
                 for interface_name in interface_names:
                     @dbus_interface_annotations(interface_name)
                     def func(self):
@@ -1213,7 +1222,7 @@
             if interface_names:
                 # Replace the class with a new subclass of it with
                 # methods, signals, etc. as created above.
-                cls = type(b"{}Alternate".format(cls.__name__),
+                cls = type(b"{0}Alternate".format(cls.__name__),
                            (cls,), attr)
         return cls
     return wrapper
@@ -1232,8 +1241,6 @@
     runtime_expansions = (Client.runtime_expansions
                           + ("dbus_object_path",))
     
-    _interface = "se.recompile.Mandos.Client"
-    
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
@@ -1241,7 +1248,7 @@
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
-        client_object_name = str(self.name).translate(
+        client_object_name = unicode(self.name).translate(
             {ord("."): ord("_"),
              ord("-"): ord("_")})
         self.dbus_object_path = (dbus.ObjectPath
@@ -1251,8 +1258,7 @@
     
     def notifychangeproperty(transform_func,
                              dbus_name, type_func=lambda x: x,
-                             variant_level=1, invalidate_only=False,
-                             _interface=_interface):
+                             variant_level=1):
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
         
@@ -1263,27 +1269,17 @@
                    to the D-Bus.  Default: no transform
         variant_level: D-Bus variant level.  Default: 1
         """
-        attrname = "_{}".format(dbus_name)
+        attrname = "_{0}".format(dbus_name)
         def setter(self, value):
             if hasattr(self, "dbus_object_path"):
                 if (not hasattr(self, attrname) or
                     type_func(getattr(self, attrname, None))
                     != type_func(value)):
-                    if invalidate_only:
-                        self.PropertiesChanged(_interface,
-                                               dbus.Dictionary(),
-                                               dbus.Array
-                                               ((dbus_name,)))
-                    else:
-                        dbus_value = transform_func(type_func(value),
-                                                    variant_level
-                                                    =variant_level)
-                        self.PropertyChanged(dbus.String(dbus_name),
-                                             dbus_value)
-                        self.PropertiesChanged(_interface,
-                                               dbus.Dictionary({
-                                    dbus.String(dbus_name):
-                                        dbus_value }), dbus.Array())
+                    dbus_value = transform_func(type_func(value),
+                                                variant_level
+                                                =variant_level)
+                    self.PropertyChanged(dbus.String(dbus_name),
+                                         dbus_value)
             setattr(self, attrname, value)
         
         return property(lambda self: getattr(self, attrname), setter)
@@ -1309,26 +1305,22 @@
     approval_delay = notifychangeproperty(dbus.UInt64,
                                           "ApprovalDelay",
                                           type_func =
-                                          lambda td: td.total_seconds()
-                                          * 1000)
+                                          timedelta_to_milliseconds)
     approval_duration = notifychangeproperty(
         dbus.UInt64, "ApprovalDuration",
-        type_func = lambda td: td.total_seconds() * 1000)
+        type_func = timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
     timeout = notifychangeproperty(dbus.UInt64, "Timeout",
-                                   type_func = lambda td:
-                                       td.total_seconds() * 1000)
+                                   type_func =
+                                   timedelta_to_milliseconds)
     extended_timeout = notifychangeproperty(
         dbus.UInt64, "ExtendedTimeout",
-        type_func = lambda td: td.total_seconds() * 1000)
+        type_func = timedelta_to_milliseconds)
     interval = notifychangeproperty(dbus.UInt64,
                                     "Interval",
                                     type_func =
-                                    lambda td: td.total_seconds()
-                                    * 1000)
+                                    timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
-    secret = notifychangeproperty(dbus.ByteArray, "Secret",
-                                  invalidate_only=True)
     
     del notifychangeproperty
     
@@ -1376,14 +1368,21 @@
     
     def approve(self, value=True):
         self.approved = value
-        gobject.timeout_add(int(self.approval_duration.total_seconds()
-                                * 1000), self._reset_approved)
+        gobject.timeout_add(timedelta_to_milliseconds
+                            (self.approval_duration),
+                            self._reset_approved)
         self.send_changedstate()
     
     ## D-Bus methods, signals & properties
+    _interface = "se.recompile.Mandos.Client"
     
     ## Interfaces
     
+    @dbus_interface_annotations(_interface)
+    def _foo(self):
+        return { "org.freedesktop.DBus.Property.EmitsChangedSignal":
+                     "false"}
+    
     ## Signals
     
     # CheckerCompleted - signal
@@ -1399,7 +1398,6 @@
         pass
     
     # PropertyChanged - signal
-    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.signal(_interface, signature="sv")
     def PropertyChanged(self, property, value):
         "D-Bus signal"
@@ -1481,8 +1479,7 @@
                            access="readwrite")
     def ApprovalDelay_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.approval_delay.total_seconds()
-                               * 1000)
+            return dbus.UInt64(self.approval_delay_milliseconds())
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
     
     # ApprovalDuration - property
@@ -1490,8 +1487,8 @@
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.approval_duration.total_seconds()
-                               * 1000)
+            return dbus.UInt64(timedelta_to_milliseconds(
+                    self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
     
     # Name - property
@@ -1510,7 +1507,7 @@
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
-        self.host = str(value)
+        self.host = unicode(value)
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1563,7 +1560,7 @@
                            access="readwrite")
     def Timeout_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.timeout.total_seconds() * 1000)
+            return dbus.UInt64(self.timeout_milliseconds())
         old_timeout = self.timeout
         self.timeout = datetime.timedelta(0, 0, 0, value)
         # Reschedule disabling
@@ -1580,16 +1577,15 @@
                 gobject.source_remove(self.disable_initiator_tag)
                 self.disable_initiator_tag = (
                     gobject.timeout_add(
-                        int((self.expires - now).total_seconds()
-                            * 1000), self.disable))
+                        timedelta_to_milliseconds(self.expires - now),
+                        self.disable))
     
     # ExtendedTimeout - property
     @dbus_service_property(_interface, signature="t",
                            access="readwrite")
     def ExtendedTimeout_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.extended_timeout.total_seconds()
-                               * 1000)
+            return dbus.UInt64(self.extended_timeout_milliseconds())
         self.extended_timeout = datetime.timedelta(0, 0, 0, value)
     
     # Interval - property
@@ -1597,7 +1593,7 @@
                            access="readwrite")
     def Interval_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.interval.total_seconds() * 1000)
+            return dbus.UInt64(self.interval_milliseconds())
         self.interval = datetime.timedelta(0, 0, 0, value)
         if getattr(self, "checker_initiator_tag", None) is None:
             return
@@ -1614,7 +1610,7 @@
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
-        self.checker_command = str(value)
+        self.checker_command = unicode(value)
     
     # CheckerRunning - property
     @dbus_service_property(_interface, signature="b",
@@ -1636,7 +1632,7 @@
     @dbus_service_property(_interface, signature="ay",
                            access="write", byte_arrays=True)
     def Secret_dbus_property(self, value):
-        self.secret = bytes(value)
+        self.secret = str(value)
     
     del _interface
 
@@ -1676,7 +1672,7 @@
     def handle(self):
         with contextlib.closing(self.server.child_pipe) as child_pipe:
             logger.info("TCP connection from: %s",
-                        str(self.client_address))
+                        unicode(self.client_address))
             logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
             
@@ -1763,8 +1759,8 @@
                         if self.server.use_dbus:
                             # Emit D-Bus signal
                             client.NeedApproval(
-                                client.approval_delay.total_seconds()
-                                * 1000, client.approved_by_default)
+                                client.approval_delay_milliseconds(),
+                                client.approved_by_default)
                     else:
                         logger.warning("Client %s was not approved",
                                        client.name)
@@ -1776,7 +1772,9 @@
                     #wait until timeout or approved
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    client.changedstate.wait(delay.total_seconds())
+                    client.changedstate.wait(
+                        float(timedelta_to_milliseconds(delay)
+                              / 1000))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1981,8 +1979,7 @@
                 try:
                     self.socket.setsockopt(socket.SOL_SOCKET,
                                            SO_BINDTODEVICE,
-                                           (self.interface + "\0")
-                                           .encode("utf-8"))
+                                           str(self.interface + '\0'))
                 except socket.error as error:
                     if error.errno == errno.EPERM:
                         logger.error("No permission to bind to"
@@ -2248,7 +2245,7 @@
     timevalue = datetime.timedelta(0)
     for s in interval.split():
         try:
-            suffix = s[-1]
+            suffix = unicode(s[-1])
             value = int(s[:-1])
             if suffix == "d":
                 delta = datetime.timedelta(value)
@@ -2261,7 +2258,7 @@
             elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError("Unknown suffix {!r}"
+                raise ValueError("Unknown suffix {0!r}"
                                  .format(suffix))
         except IndexError as e:
             raise ValueError(*(e.args))
@@ -2284,7 +2281,8 @@
         # Close all standard open file descriptors
         null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
-            raise OSError(errno.ENODEV, "{} not a character device"
+            raise OSError(errno.ENODEV,
+                          "{0} not a character device"
                           .format(os.devnull))
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
@@ -2300,7 +2298,7 @@
     
     parser = argparse.ArgumentParser()
     parser.add_argument("-v", "--version", action="version",
-                        version = "%(prog)s {}".format(version),
+                        version = "%(prog)s {0}".format(version),
                         help="show version number and exit")
     parser.add_argument("-i", "--interface", metavar="IF",
                         help="Bind to interface IF")
@@ -2405,9 +2403,8 @@
     del options
     # Force all strings to be unicode
     for option in server_settings.keys():
-        if isinstance(server_settings[option], bytes):
-            server_settings[option] = (server_settings[option]
-                                       .decode("utf-8"))
+        if type(server_settings[option]) is str:
+            server_settings[option] = unicode(server_settings[option])
     # Force all boolean options to be boolean
     for option in ("debug", "use_dbus", "use_ipv6", "restore",
                    "foreground", "zeroconf"):
@@ -2446,7 +2443,7 @@
     
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({}) [%(process)d]:'
+                               ('Mandos ({0}) [%(process)d]:'
                                 ' %(levelname)s: %(message)s'
                                 .format(server_settings
                                         ["servicename"])))
@@ -2556,8 +2553,7 @@
                                        protocol = protocol, bus = bus)
         if server_settings["interface"]:
             service.interface = (if_nametoindex
-                                 (server_settings["interface"]
-                                  .encode("utf-8")))
+                                 (str(server_settings["interface"])))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -2587,7 +2583,7 @@
             os.remove(stored_state_path)
         except IOError as e:
             if e.errno == errno.ENOENT:
-                logger.warning("Could not load persistent state: {}"
+                logger.warning("Could not load persistent state: {0}"
                                 .format(os.strerror(e.errno)))
             else:
                 logger.critical("Could not load persistent state:",
@@ -2598,7 +2594,7 @@
                            "EOFError:", exc_info=e)
     
     with PGPEngine() as pgp:
-        for client_name, client in clients_data.items():
+        for client_name, client in clients_data.iteritems():
             # Skip removed clients
             if client_name not in client_settings:
                 continue
@@ -2629,14 +2625,14 @@
                 if datetime.datetime.utcnow() >= client["expires"]:
                     if not client["last_checked_ok"]:
                         logger.warning(
-                            "disabling client {} - Client never "
+                            "disabling client {0} - Client never "
                             "performed a successful checker"
                             .format(client_name))
                         client["enabled"] = False
                     elif client["last_checker_status"] != 0:
                         logger.warning(
-                            "disabling client {} - Client last"
-                            " checker failed with error code {}"
+                            "disabling client {0} - Client "
+                            "last checker failed with error code {1}"
                             .format(client_name,
                                     client["last_checker_status"]))
                         client["enabled"] = False
@@ -2645,7 +2641,7 @@
                                              .utcnow()
                                              + client["timeout"])
                         logger.debug("Last checker succeeded,"
-                                     " keeping {} enabled"
+                                     " keeping {0} enabled"
                                      .format(client_name))
             try:
                 client["secret"] = (
@@ -2654,7 +2650,7 @@
                                 ["secret"]))
             except PGPError:
                 # If decryption fails, we use secret from new settings
-                logger.debug("Failed to decrypt {} old secret"
+                logger.debug("Failed to decrypt {0} old secret"
                              .format(client_name))
                 client["secret"] = (
                     client_settings[client_name]["secret"])
@@ -2668,7 +2664,7 @@
         clients_data[client_name] = client_settings[client_name]
     
     # Create all client objects
-    for client_name, client in clients_data.items():
+    for client_name, client in clients_data.iteritems():
         tcp_server.clients[client_name] = client_class(
             name = client_name, settings = client,
             server_settings = server_settings)
@@ -2681,7 +2677,7 @@
             try:
                 with pidfile:
                     pid = os.getpid()
-                    pidfile.write("{}\n".format(pid).encode("utf-8"))
+                    pidfile.write(str(pid) + "\n".encode("utf-8"))
             except IOError:
                 logger.error("Could not write to file %r with PID %d",
                              pidfilename, pid)
@@ -2733,8 +2729,8 @@
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    { c.dbus_object_path: c.GetAll("")
-                      for c in tcp_server.clients.itervalues() },
+                    ((c.dbus_object_path, c.GetAll(""))
+                     for c in tcp_server.clients.itervalues()),
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")
@@ -2778,8 +2774,8 @@
                 
                 # A list of attributes that can not be pickled
                 # + secret.
-                exclude = { "bus", "changedstate", "secret",
-                            "checker", "server_settings" }
+                exclude = set(("bus", "changedstate", "secret",
+                               "checker", "server_settings"))
                 for name, typ in (inspect.getmembers
                                   (dbus.service.Object)):
                     exclude.add(name)
@@ -2808,7 +2804,7 @@
                 except NameError:
                     pass
             if e.errno in (errno.ENOENT, errno.EACCES, errno.EEXIST):
-                logger.warning("Could not save persistent state: {}"
+                logger.warning("Could not save persistent state: {0}"
                                .format(os.strerror(e.errno)))
             else:
                 logger.warning("Could not save persistent state:",

=== modified file 'mandos-ctl'
--- mandos-ctl	2014-10-05 20:08:58 +0000
+++ mandos-ctl	2014-07-24 01:35:55 +0000
@@ -42,7 +42,7 @@
 
 import dbus
 
-if sys.version_info.major == 2:
+if sys.version_info[0] == 2:
     str = unicode
 
 locale.setlocale(locale.LC_ALL, "")
@@ -72,12 +72,18 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.9"
+version = "1.6.7"
+
+def timedelta_to_milliseconds(td):
+    """Convert a datetime.timedelta object to milliseconds"""
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
     return ("{days}{hours:02}:{minutes:02}:{seconds:02}"
-            .format(days = "{}T".format(td.days) if td.days else "",
+            .format(days = "{0}T".format(td.days) if td.days else "",
                     hours = td.seconds // 3600,
                     minutes = (td.seconds % 3600) // 60,
                     seconds = td.seconds % 60,
@@ -243,10 +249,10 @@
     # Print header line
     print(format_string.format(**tablewords))
     for client in clients:
-        print(format_string.format(**{ key:
+        print(format_string.format(**dict((key,
                                            valuetostring(client[key],
-                                                         key)
-                                       for key in keywords }))
+                                                         key))
+                                          for key in keywords)))
 
 def has_actions(options):
     return any((options.enable,
@@ -271,7 +277,7 @@
 def main():
     parser = argparse.ArgumentParser()
     parser.add_argument("--version", action="version",
-                        version = "%(prog)s {}".format(version),
+                        version = "%(prog)s {0}".format(version),
                         help="show version number and exit")
     parser.add_argument("-a", "--all", action="store_true",
                         help="Select all clients")
@@ -366,17 +372,18 @@
     clients={}
     
     if options.all or not options.client:
-        clients = { bus.get_object(busname, path): properties
-                    for path, properties in mandos_clients.items() }
+        clients = dict((bus.get_object(busname, path), properties)
+                       for path, properties in
+                       mandos_clients.items())
     else:
         for name in options.client:
-            for path, client in mandos_clients.items():
+            for path, client in mandos_clients.iteritems():
                 if client["Name"] == name:
                     client_objc = bus.get_object(busname, path)
                     clients[client_objc] = client
                     break
             else:
-                print("Client not found on server: {!r}"
+                print("Client not found on server: {0!r}"
                       .format(name), file=sys.stderr)
                 sys.exit(1)
     
@@ -405,8 +412,8 @@
                 """Set a Client D-Bus property, converted
                 from a string to milliseconds."""
                 set_client_prop(prop,
-                                string_to_delta(value).total_seconds()
-                                * 1000)
+                                timedelta_to_milliseconds
+                                (string_to_delta(value)))
             if options.remove:
                 mandos_serv.RemoveClient(client.__dbus_object_path__)
             if options.enable:

=== modified file 'mandos-keygen'
--- mandos-keygen	2014-10-05 20:08:58 +0000
+++ mandos-keygen	2014-07-17 03:24:57 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.9"
+VERSION="1.6.7"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA
@@ -363,7 +363,7 @@
 	    }
 	}' < "$SECFILE"
     if [ -n "$ssh_fingerprint" ]; then
-	echo 'checker = ssh-keyscan %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp=%%(host)s" %(ssh_fingerprint)s"'
+	echo 'checker = ssh-keyscan %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp="%%(host)s %(ssh_fingerprint)s"'
 	echo "ssh_fingerprint = ${ssh_fingerprint}"
     fi
 fi

=== modified file 'mandos-monitor'
--- mandos-monitor	2014-10-05 20:08:58 +0000
+++ mandos-monitor	2014-07-24 02:58:45 +0000
@@ -48,7 +48,7 @@
 
 import locale
 
-if sys.version_info.major == 2:
+if sys.version_info[0] == 2:
     str = unicode
 
 locale.setlocale(locale.LC_ALL, '')
@@ -60,7 +60,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.9"
+version = "1.6.7"
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
@@ -87,9 +87,9 @@
         self.proxy = proxy_object # Mandos Client proxy object
         self.properties = dict() if properties is None else properties
         self.property_changed_match = (
-            self.proxy.connect_to_signal("PropertiesChanged",
-                                         self.properties_changed,
-                                         dbus.PROPERTIES_IFACE,
+            self.proxy.connect_to_signal("PropertyChanged",
+                                         self._property_changed,
+                                         client_interface,
                                          byte_arrays=True))
         
         if properties is None:
@@ -100,12 +100,16 @@
         
         super(MandosClientPropertyCache, self).__init__(**kwargs)
     
-    def properties_changed(self, interface, properties, invalidated):
-        """This is called whenever we get a PropertiesChanged signal
-        It updates the changed properties in the "properties" dict.
+    def _property_changed(self, property, value):
+        """Helper which takes positional arguments"""
+        return self.property_changed(property=property, value=value)
+    
+    def property_changed(self, property=None, value=None):
+        """This is called whenever we get a PropertyChanged signal
+        It updates the changed property in the "properties" dict.
         """
         # Update properties dict with new value
-        self.properties.update(properties)
+        self.properties[property] = value
     
     def delete(self):
         self.property_changed_match.remove()
@@ -157,7 +161,7 @@
                                          self.rejected,
                                          client_interface,
                                          byte_arrays=True))
-        self.logger('Created client {}'
+        self.logger('Created client {0}'
                     .format(self.properties["Name"]), level=0)
     
     def using_timer(self, flag):
@@ -175,52 +179,52 @@
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
-            self.logger('Checker for client {} (command "{}")'
+            self.logger('Checker for client {0} (command "{1}")'
                         ' succeeded'.format(self.properties["Name"],
                                             command), level=0)
             self.update()
             return
         # Checker failed
         if os.WIFEXITED(condition):
-            self.logger('Checker for client {} (command "{}") failed'
-                        ' with exit code {}'
+            self.logger('Checker for client {0} (command "{1}")'
+                        ' failed with exit code {2}'
                         .format(self.properties["Name"], command,
                                 os.WEXITSTATUS(condition)))
         elif os.WIFSIGNALED(condition):
-            self.logger('Checker for client {} (command "{}") was'
-                        ' killed by signal {}'
+            self.logger('Checker for client {0} (command "{1}") was'
+                        ' killed by signal {2}'
                         .format(self.properties["Name"], command,
                                 os.WTERMSIG(condition)))
         elif os.WCOREDUMP(condition):
-            self.logger('Checker for client {} (command "{}") dumped'
-                        ' core'.format(self.properties["Name"],
-                                       command))
+            self.logger('Checker for client {0} (command "{1}")'
+                        ' dumped core'
+                        .format(self.properties["Name"], command))
         else:
-            self.logger('Checker for client {} completed'
+            self.logger('Checker for client {0} completed'
                         ' mysteriously'
                         .format(self.properties["Name"]))
         self.update()
     
     def checker_started(self, command):
         """Server signals that a checker started."""
-        self.logger('Client {} started checker "{}"'
+        self.logger('Client {0} started checker "{1}"'
                     .format(self.properties["Name"],
                             command), level=0)
     
     def got_secret(self):
-        self.logger('Client {} received its secret'
+        self.logger('Client {0} received its secret'
                     .format(self.properties["Name"]))
     
     def need_approval(self, timeout, default):
         if not default:
-            message = 'Client {} needs approval within {} seconds'
+            message = 'Client {0} needs approval within {1} seconds'
         else:
-            message = 'Client {} will get its secret in {} seconds'
+            message = 'Client {0} will get its secret in {1} seconds'
         self.logger(message.format(self.properties["Name"],
                                    timeout/1000))
     
     def rejected(self, reason):
-        self.logger('Client {} was rejected; reason: {}'
+        self.logger('Client {0} was rejected; reason: {1}'
                     .format(self.properties["Name"], reason))
     
     def selectable(self):
@@ -270,9 +274,9 @@
             else:
                 timer = datetime.timedelta()
             if self.properties["ApprovedByDefault"]:
-                message = "Approval in {}. (d)eny?"
+                message = "Approval in {0}. (d)eny?"
             else:
-                message = "Denial in {}. (a)pprove?"
+                message = "Denial in {0}. (a)pprove?"
             message = message.format(str(timer).rsplit(".", 1)[0])
             self.using_timer(True)
         elif self.properties["LastCheckerStatus"] != 0:
@@ -286,13 +290,13 @@
                 timer = max(expires - datetime.datetime.utcnow(),
                             datetime.timedelta())
             message = ('A checker has failed! Time until client'
-                       ' gets disabled: {}'
+                       ' gets disabled: {0}'
                        .format(str(timer).rsplit(".", 1)[0]))
             self.using_timer(True)
         else:
             message = "enabled"
             self.using_timer(False)
-        self._text = "{}{}".format(base, message)
+        self._text = "{0}{1}".format(base, message)
         
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
@@ -373,15 +377,14 @@
         else:
             return key
     
-    def properties_changed(self, interface, properties, invalidated):
-        """Call self.update() if any properties changed.
+    def property_changed(self, property=None, **kwargs):
+        """Call self.update() if old value is not new value.
         This overrides the method from MandosClientPropertyCache"""
-        old_values = { key: self.properties.get(key)
-                       for key in properties.keys() }
-        super(MandosClientWidget, self).properties_changed(
-            interface, properties, invalidated)
-        if any(old_values[key] != self.properties.get(key)
-               for key in old_values):
+        property_name = str(property)
+        old_value = self.properties.get(property_name)
+        super(MandosClientWidget, self).property_changed(
+            property=property, **kwargs)
+        if self.properties.get(property_name) != old_value:
             self.update()
 
 
@@ -466,8 +469,8 @@
         self.main_loop = gobject.MainLoop()
     
     def client_not_found(self, fingerprint, address):
-        self.log_message("Client with address {} and fingerprint {}"
-                         " could not be found"
+        self.log_message("Client with address {0} and fingerprint"
+                         " {1} could not be found"
                          .format(address, fingerprint))
     
     def rebuild(self):
@@ -491,7 +494,7 @@
         if level < self.log_level:
             return
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw("{}: {}".format(timestamp, message),
+        self.log_message_raw("{0}: {1}".format(timestamp, message),
                              level=level)
     
     def log_message_raw(self, markup, level=1):
@@ -510,7 +513,7 @@
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        self.log_message("Log visibility changed to: {}"
+        self.log_message("Log visibility changed to: {0}"
                          .format(self.log_visible), level=0)
     
     def change_log_display(self):
@@ -522,7 +525,7 @@
             self.log_wrap = "clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        self.log_message("Wrap mode: {}".format(self.log_wrap),
+        self.log_message("Wrap mode: {0}".format(self.log_wrap),
                          level=0)
     
     def find_and_remove_client(self, path, name):
@@ -534,7 +537,7 @@
             client = self.clients_dict[path]
         except KeyError:
             # not found?
-            self.log_message("Unknown client {!r} ({!r}) removed"
+            self.log_message("Unknown client {0!r} ({1!r}) removed"
                              .format(name, path))
             return
         client.delete()

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-10-05 20:08:58 +0000
+++ mandos.lsm	2014-07-17 03:24:57 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.6.9
-Entered-date:	2014-10-05
+Version:	1.6.7
+Entered-date:	2014-07-17
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.9.orig.tar.gz
+		161K mandos_1.6.7.orig.tar.gz
 Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.9.orig.tar.gz
+		161K mandos_1.6.7.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other

=== modified file 'mandos.service'
--- mandos.service	2014-10-05 19:39:25 +0000
+++ mandos.service	2013-12-31 16:02:18 +0000
@@ -1,13 +1,12 @@
 [Unit]
 Description=Server of encrypted passwords to Mandos clients
-Documentation=man:intro(8mandos) man:mandos(8)
 
 [Service]
 Type=simple
 ## Type=dbus is not appropriate, because Mandos also needs to announce
 ## its ZeroConf service and be reachable on the network.
 #Type=dbus
-#BusName=se.recompile.Mandos
+BusName=se.recompile.Mandos
 # If you add --no-dbus, also comment out BusName above, and vice versa
 ExecStart=/usr/sbin/mandos --foreground
 Restart=always

=== removed directory 'plugin-helpers'
=== modified file 'plugin-runner.c'
--- plugin-runner.c	2015-06-28 16:35:27 +0000
+++ plugin-runner.c	2014-07-16 01:41:23 +0000
@@ -76,7 +76,6 @@
 #define BUFFER_SIZE 256
 
 #define PDIR "/lib/mandos/plugins.d"
-#define PHDIR "/lib/mandos/plugin-helpers"
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
 const char *argp_program_version = "plugin-runner " VERSION;
@@ -348,7 +347,6 @@
 
 int main(int argc, char *argv[]){
   char *plugindir = NULL;
-  char *pluginhelperdir = NULL;
   char *argfile = NULL;
   FILE *conffp;
   struct dirent **direntries = NULL;
@@ -416,10 +414,6 @@
       .doc = "Group ID the plugins will run as", .group = 3 },
     { .name = "debug", .key = 132,
       .doc = "Debug mode", .group = 4 },
-    { .name = "plugin-helper-dir", .key = 133,
-      .arg = "DIRECTORY",
-      .doc = "Specify a different plugin helper directory",
-      .group = 2 },
     /*
      * These reproduce what we would get without ARGP_NO_HELP
      */
@@ -551,13 +545,6 @@
     case 132:			/* --debug */
       debug = true;
       break;
-    case 133:			/* --plugin-helper-dir */
-      free(pluginhelperdir);
-      pluginhelperdir = strdup(arg);
-      if(pluginhelperdir != NULL){
-	errno = 0;
-      }
-      break;
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -614,7 +601,6 @@
     case 130:			/* --userid */
     case 131:			/* --groupid */
     case 132:			/* --debug */
-    case 133:			/* --plugin-helper-dir */
     case '?':			/* --help */
     case -3:			/* --usage */
     case 'V':			/* --version */
@@ -775,24 +761,6 @@
     goto fallback;
   }
   
-  {
-    char *pluginhelperenv;
-    bool bret = true;
-    ret = asprintf(&pluginhelperenv, "MANDOSPLUGINHELPERDIR=%s",
-		   pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
-    if(ret != -1){
-      bret = add_environment(getplugin(NULL), pluginhelperenv, true);
-    }
-    if(ret == -1 or not bret){
-      error(0, errno, "Failed to set MANDOSPLUGINHELPERDIR"
-	    " environment variable to \"%s\" for all plugins\n",
-	    pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
-    }
-    if(ret != -1){
-      free(pluginhelperenv);
-    }
-  }
-  
   if(debug){
     for(plugin *p = plugin_list; p != NULL; p=p->next){
       fprintf(stderr, "Plugin: %s has %d arguments\n",
@@ -1368,7 +1336,6 @@
   free_plugin_list();
   
   free(plugindir);
-  free(pluginhelperdir);
   free(argfile);
   
   return exitstatus;

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2015-06-28 16:35:27 +0000
+++ plugin-runner.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2015-06-28">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -114,9 +114,6 @@
       <arg><option>--plugin-dir=<replaceable
       >DIRECTORY</replaceable></option></arg>
       <sbr/>
-      <arg><option>--plugin-helper-dir=<replaceable
-      >DIRECTORY</replaceable></option></arg>
-      <sbr/>
       <arg><option>--config-file=<replaceable
       >FILE</replaceable></option></arg>
       <sbr/>
@@ -323,21 +320,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--plugin-helper-dir
-	<replaceable>DIRECTORY</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Specify a different plugin helper directory.  The default
-	    is <filename>/lib/mandos/plugin-helpers</filename>, which
-	    will exist in the initial <acronym>RAM</acronym> disk
-	    environment.  (This will simply be passed to all plugins
-	    via the <envar>MANDOSPLUGINHELPERDIR</envar> environment
-	    variable.  See <xref linkend="writing_plugins"/>)
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>--config-file
 	<replaceable>FILE</replaceable></option></term>
 	<listitem>
@@ -444,11 +426,7 @@
       <para>
 	The plugin will run in the initial RAM disk environment, so
 	care must be taken not to depend on any files or running
-	services not available there.  Any helper executables required
-	by the plugin (which are not in the <envar>PATH</envar>) can
-	be placed in the plugin helper directory, the name of which
-	will be made available to the plugin via the
-	<envar>MANDOSPLUGINHELPERDIR</envar> environment variable.
+	services not available there.
       </para>
       <para>
 	The plugin must exit cleanly and free all allocated resources
@@ -497,9 +475,7 @@
       only passes on its environment to all the plugins.  The
       environment passed to plugins can be modified using the
       <option>--global-env</option> and <option>--env-for</option>
-      options.  Also, the <option>--plugin-helper-dir</option> option
-      will affect the environment variable
-      <envar>MANDOSPLUGINHELPERDIR</envar> for the plugins.
+      options.
     </para>
   </refsect1>
   

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2014-08-09 23:37:07 +0000
+++ plugins.d/askpass-fifo.c	2014-03-29 02:38:15 +0000
@@ -23,7 +23,7 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-#include <sys/types.h>		/* uid_t, gid_t, ssize_t */
+#include <sys/types.h>		/* ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
 #include <iso646.h>		/* and */
 #include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
@@ -44,8 +44,6 @@
 #include <string.h> 		/* strerror() */
 #include <stdarg.h>		/* va_list, va_start(), ... */
 
-uid_t uid = 65534;
-gid_t gid = 65534;
 
 /* Function to use when printing errors */
 __attribute__((format (gnu_printf, 3, 4)))
@@ -76,9 +74,6 @@
   int ret = 0;
   ssize_t sret;
   
-  uid = getuid();
-  gid = getgid();
-  
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
@@ -124,16 +119,6 @@
     }
   }
   
-  /* Lower group privileges  */
-  if(setgid(gid) == -1){
-    error_plus(0, errno, "setgid");
-  }
-  
-  /* Lower user privileges */
-  if(setuid(uid) == -1){
-    error_plus(0, errno, "setuid");
-  }
-  
   /* Read from FIFO */
   char *buf = NULL;
   size_t buf_len = 0;

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2014-08-20 21:46:38 +0000
+++ plugins.d/mandos-client.c	2014-07-15 23:52:00 +0000
@@ -1650,11 +1650,6 @@
 	_exit(EXIT_FAILURE);
       }
     } else {
-      if(hook_pid == -1){
-	perror_plus("fork");
-	free(direntry);
-	continue;
-      }
       int status;
       if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
 	perror_plus("waitpid");

